<template>
  <div id="app" class="app">
    <transition name="fade" mode="out-in">
      <template v-if="!appMode">
        <div class="container container--v-center" key="mode-selector">
          <app-header />
          <mode-selector />
        </div>
      </template>

      <template v-else>
        <div class="container" key="data-table">
          <div class="page-header">
            <app-header :is-small="true" />
            <app-button :is-small="true" @button-click="resetAppMode">Change app mode</app-button>
          </div>
          <data-table />
          <data-table-pagination v-if="activeCharacters.length" />
        </div>
      </template>
    </transition>

    <transition name="fade">
      <loading-spinner v-if="isLoading" key="loading-spinner" />
    </transition>
  </div>
</template>

<script lang="ts">
import Vue from 'vue';
import { mapActions, mapGetters, mapState } from 'vuex';
import { AppMode } from '@/types';

// Components
import DataTable from '@/components/DataTable/DataTable.vue';
import DataTablePagination from '@/components/DataTable/DataTablePagination.vue';
import ModeSelector from '@/components/ModeSelector.vue';
import AppButton from '@/components/AppButton.vue';
import AppHeader from '@/components/Layout/AppHeader.vue';
import LoadingSpinner from '@/components/LoadingSpinner.vue';

export default Vue.extend({
  name: 'App',

  components: {
    AppButton,
    AppHeader,
    DataTable,
    LoadingSpinner,
    ModeSelector,
    DataTablePagination
  },

  computed: {
    ...mapGetters([
      'activeCharacters'
    ]),

    ...mapState({
      appMode: (state: any) => state.global.appMode as AppMode,
      isLoading: (state: any) => state.global.isLoading as boolean
    })
  },

  methods: {
    ...mapActions([
      'setAppMode'
    ]),

    resetAppMode () {
      this.setAppMode(null);
    }
  }
});
</script>

<style lang="scss">
@import './assets/scss/reset.scss';

:root {
  --font-family-headings: 'Merriweather', serif;
  --font-family-primary: 'Work Sans', sans-serif;
  --color-primary: #333;
  --color-light: #f0f0f0;
  --color-accent: #090da0;
  --color-lanister: #860904;
  --color-starks: #166A8E;
}

body {
  color: var(--color-primary);
  font-family: var(--font-family-primary)
}

h1, h2, h3 {
  font-family: var(--font-family-headings)
}

.app {
  display: flex;
  flex-direction: column;
  min-height: 100vh;
  margin: 0 auto;
}

.container {
  width: 80%;
  max-width: 1280px;
  margin: 0 auto;
  padding: 3rem 0;

  &--v-center {
    margin: auto;
  }
}

.page-header {
  display: flex;
  justify-content: space-between;
  align-items: center;
  margin-bottom: 2rem;
}

.fade-enter-active, .fade-leave-active {
  transition: opacity .4s;
}

.fade-enter, .fade-leave-to {
  opacity: 0;
}
</style>
